package com.icontrols.dust;


import javax.net.ssl.SSLContext;

import org.apache.http.conn.ssl.NoopHostnameVerifier;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.springframework.http.client.HttpComponentsClientHttpRequestFactory;
import org.springframework.web.client.RestTemplate;

public class GetRestTemplate {
	
	public RestTemplate getOrg()
	{
		try
		{
			// 오리지날
			RestTemplate restTemplate = new RestTemplate();
			return restTemplate;
			
		}catch(Exception e )
		{
			e.printStackTrace();
		}
		
		return null;
	}
	
	public RestTemplate get2Modify()
	{
		try
		{
			// 유플러스 이벤트 처리가 HTTPS 가 안되었을 때
			CloseableHttpClient httpClient = HttpClients.custom().setSSLHostnameVerifier(new NoopHostnameVerifier()).build();
			
			HttpComponentsClientHttpRequestFactory requestFactory = new HttpComponentsClientHttpRequestFactory();
			requestFactory.setHttpClient(httpClient);
	
			RestTemplate restTemplate = new RestTemplate(requestFactory);

		
			return restTemplate;
			
		}catch(Exception e )
		{
			e.printStackTrace();
		}
		
		return null;
	}
	
	/*
	public RestTemplate getModify()
	{
		try
		{
			// 유플러스 이벤트 처리가 위에꺼로 계속 잘되다가 품질팀 검수 서버로 변경하니 또 안 되어서 수정함
			// 참고 URL https://code.i-harness.com/ko-kr/q/293f39 
			// SSL 인증서 오류를 무시하는 방법이기 때문에 인증서를 정상적으로 적용시 오리지널 RestTemplate을 사용하게 될꺼 같음
						
			final SSLContext sslContext = new SSLContextBuilder()
				    .loadTrustMaterial(null, (x509CertChain, authType) -> true).build();
			
			CloseableHttpClient httpClient = HttpClients.custom().setSSLHostnameVerifier(NoopHostnameVerifier.INSTANCE).setSSLContext(sslContext).build();
	
			HttpComponentsClientHttpRequestFactory requestFactory = new HttpComponentsClientHttpRequestFactory();
			requestFactory.setHttpClient(httpClient);
	
			RestTemplate restTemplate = new RestTemplate(requestFactory);
		
			return restTemplate;
			
		}catch(Exception e )
		{
			e.printStackTrace();
		}
		
		return null;
	}
	*/
}
