package com.icontrols.dust;

import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathFactory;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Node;


public class ParserXML {
	private static final Logger logger = LoggerFactory.getLogger(ParserXML.class);
	private int Dong;
	private int Ho;
	private int ResultCode;
	public ParserXML(Document doc)
	{
		try
		{
		    // xpath 생성
	        XPath xpath = XPathFactory.newInstance().newXPath();
	
	        // id 가 c2 인 Node의 val attribute 값 가져오기
	        Node iMap = (Node)xpath.evaluate("//imap", doc, XPathConstants.NODE);
	        System.out.println( "address : " + iMap.getAttributes().getNamedItem("address").getTextContent() );
	        System.out.println( "sender : "+iMap.getAttributes().getNamedItem("sender").getTextContent() );
	        String dongho = iMap.getAttributes().getNamedItem("sender").getTextContent();
	        
	        String searchDong = "동";
	        String searchHo ="호";
	        
	        boolean bSenderServer = false;
	        
	        if( dongho.indexOf("d") >= 0 )
	        {
	        	searchDong = "d";
	        	searchHo = "h";
	        }
	        else if( dongho.indexOf("valley") >= 0)
	        {
	        	bSenderServer = true;
		        Dong = 101;
		        Ho = 101;
	        }
	        
	        if( bSenderServer == false )
	        {
		        int idxdong = dongho.indexOf(searchDong);
		        int idxho = dongho.indexOf(searchHo);
		        
		        String dong = dongho.substring(0, idxdong);
		        dong = dong.trim();
		        String ho = dongho.substring(idxdong + 1, idxho);
		        ho = ho.trim();
		        System.out.println("[동:" + dong + "호:" + ho+ "]");
		        
		        Dong = Integer.parseInt(dong);
		        Ho = Integer.parseInt(ho);
	        }
	        setResultCode(1);
		}
		catch( Exception e)
		{
			logger.error("message : " + e);
			setResultCode(-1);
		}
	}
	public int getDong() {
		return Dong;
	}
	public void setDong(int dong) {
		Dong = dong;
	}
	public int getHo() {
		return Ho;
	}
	public void setHo(int ho) {
		Ho = ho;
	}
	public int getResultCode() {
		return ResultCode;
	}
	public void setResultCode(int resultCode) {
		ResultCode = resultCode;
	}
}
